Index: Commands2.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands2.cpp,v
retrieving revision 1.42
retrieving revision 1.119
diff -u -p -b -r1.42 -r1.119
--- Commands2.cpp	10 Jul 2004 14:14:45 -0000	1.42
+++ Commands2.cpp	23 Jan 2005 01:34:53 -0000	1.119
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Commands2.cpp
+// $Id: Commands2.cpp,v 1.119 2005/01/23 01:34:53 klas Exp $
+//
 // Usage: Ftp commands and data transfer functions
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
@@ -11,25 +12,18 @@
 #define __NETINCLS__
 #include "Commands.h"
 
-bool Commands::quit(User *user, string argument)
+bool Commands::quit(User *user, string argument, unsigned int flag)
 {
-  Commands::ftp_send(user, "221 Goodbye.");
-  if(user->logged_in == LOGGED_IN)
-  {
-    string log;
-    log = "User " + user->user_name + " logged out.";
-    pthread_mutex_lock(&sys_log_lock);
-    syslog(LOG_INFO, log.c_str());
-    pthread_mutex_unlock(&sys_log_lock);
-  }
-  pthread_mutex_lock(&user->lock);
+  Commands::ftp_send(user, "221 Goodbye. You transfered a total of " + util.itos(user->total_transfered) + " bytes.");
+
+  sem_wait(&user->user_lock);
   user->logged_in = LOGGED_OUT;
-  pthread_mutex_unlock(&user->lock);
+  sem_post(&user->user_lock);
   close(user->socket_id);
   return(true);
 }
 
-bool Commands::user(User *user, string user_name)
+bool Commands::user(User *user, string user_name, unsigned int flag)
 {
   if(user->logged_in == LOGGED_IN)
   {
@@ -37,9 +31,27 @@ bool Commands::user(User *user, string u
     return(false);
   }
 
+#ifdef USE_TLS
+  string failure;
+  if(config->get_user(user_name).encryption == FORCE &&
+      !user->settings.test(TLS_ENABLED))
+    failure = "421 You muse enable encryption before logging in, disconnecting.";
+  else if(config->get_user(user_name).encryption == DENY &&
+      user->settings.test(TLS_ENABLED))
+    failure =  "421 Sorry, you are not allowed to connect with encryption enabled, disconnecting.";
+
+  if(!failure.empty())
+  {
+    Commands::ftp_send(user, failure);
+    sem_wait(&user->user_lock);
+    user->logged_in = LOGGED_OUT;
+    sem_post(&user->user_lock);
+    return(false);
+  }
+#endif // USE_TLS
   int current_connections = 0;
-  vector<User*>::iterator user_it;
-  for(user_it = user_list.begin(); user_it != user_list.end(); user_it++){
+  for(vector<User*>::iterator user_it = user_list.begin();
+      user_it != user_list.end(); user_it++){
     if((*user_it)->user_name == user_name)
       current_connections++;
   }
@@ -48,28 +60,25 @@ bool Commands::user(User *user, string u
      return(false);
   }
 
-  pthread_mutex_lock(&user->lock);
+  sem_wait(&user->user_lock);
   user->user_name = user_name;
-  pthread_mutex_unlock(&user->lock);
-  Commands::ftp_send(user, "331 Password required for " + user_name + ".");
-  pthread_mutex_lock(&user->lock);
   user->logged_in = USER_SUPPLIED;
-  pthread_mutex_unlock(&user->lock);
+  sem_post(&user->user_lock);
+  Commands::ftp_send(user, "331 Password required for " + user_name + ".");
 
   return(true);
 }
 
-bool Commands::abor(User *user, string argument) // FIXME please?
+bool Commands::abor(User *user, string argument, unsigned int flag) // FIXME please?
 {
   ftp_send(user, "502 Command not implemented.");
   return(true);
 }
 
-bool Commands::pass(User *user, string passwd)
+bool Commands::pass(User *user, string passwd, unsigned int flag)
 {
-  struct spwd *shadow; // the shadow struct
-  char *salt;
-  string pass;
+  char pwdata[PWBUF_SIZE];
+  struct passwd pwd, *pwd_ptr;
   
   // before everything else, lets check if it is really time for pass...
   if(user->logged_in != USER_SUPPLIED)
@@ -84,101 +93,79 @@ bool Commands::pass(User *user, string p
     return(false);
   }
 
-  setspent(); // open the shadow database...
-  shadow = getspnam(user->user_name.c_str()); // find the user...
-  if(!shadow || config->get_user(user->user_name).noftp) // if user doesn't exist or isnt' allowed to login.
+  seteuid(0); // we need to become root to check the user
+  // pam stuff
+  struct pam_data *auth_data = new struct pam_data;
+  struct pam_conv pamconv = { &pam_conversate, auth_data };
+  int pam_error = 0;
+
+  auth_data->user_name = user->user_name;
+  auth_data->password = passwd;
+
+  sem_wait(&comm.pam_lock);
+  pam_error = pam_start("babyftpd", user->user_name.c_str(),
+      &pamconv, &user->pamh);
+
+  if(pam_error == 0)
   {
-    struct timeval times;
-    string message;
-    times.tv_sec = 5;
-    times.tv_usec = 0;
-    select(0, NULL, NULL, NULL, &times);
-    pthread_mutex_lock(&user->lock);
-    user->logged_in = NOT_LOGGED_IN;
-    user->failed_logins++;
-    if(user->failed_logins > 2)
+    pam_error = pam_authenticate(user->pamh, 0);
+    if(pam_error == 0)
     {
-      user->logged_in = LOGGED_OUT;
-      message = "421 To many failed logins. Disconnecting.";
+      pam_error = pam_acct_mgmt(user->pamh, 0);
+      if(pam_error == 0)
+        pam_error = pam_setcred(user->pamh, PAM_ESTABLISH_CRED);
     }
-    else
-      message = "530 Login denied.";
-    pthread_mutex_unlock(&user->lock);
-    endspent(); // close the shadow database...
-    ftp_send(user, message);
-    return(false);
   }
-  salt = shadow->sp_pwdp; // set the salt...
-  passwd = crypt(passwd.c_str(), salt); // encrypt the user supplied password
-  pass = shadow->sp_pwdp; // get the encrypted password from the shadow database
-  endspent(); // close the shadow database
-  if(passwd != pass) // no match...
-  {
-    string log, message;
-    struct timeval times;
-    times.tv_sec = 5;
-    times.tv_usec = 0;
-    select(0, NULL, NULL, NULL, &times);
-    pthread_mutex_lock(&user->lock);
-    user->logged_in = NOT_LOGGED_IN;
-    user->failed_logins++;
-    if(user->failed_logins > 2)
+  if(pam_error != 0)
     {
-      user->logged_in = LOGGED_OUT;
-      message = "421 To many failed logins. Disconnecting.";
+    pam_end(user->pamh, pam_error);
+    sem_post(&pam_lock);
+    seteuid(config->general.user); // and back to some other user..
     }
-    else
-      message = "530 Login denied.";
-    pthread_mutex_unlock(&user->lock);
 
-    ftp_send(user, message);
+  delete auth_data;
 
-    log = "Failed login attempt from ";
-    if(user->host_name.size() > 0)
-      log.append(user->host_name);
-    else
-      log.append(inet_ntoa(user->ctrl_addr.sin_addr));
-    log += " with user name " + user->user_name + ".";
-    
-    pthread_mutex_lock(&sys_log_lock);
-    syslog(LOG_NOTICE, log.c_str());
-    pthread_mutex_unlock(&sys_log_lock);
-    return(false);
-  }
-  else // match =)
+  if(pam_error == 0)
+  {
+    pam_open_session(user->pamh, PAM_SILENT);
+    user->settings.set(PAM_DONE);
+
+    const char *pam_username;
+    pam_get_item(user->pamh, PAM_USER,
+        (reinterpret_cast<const void**>(&pam_username)));
+    sem_post(&pam_lock);
+    if(user->user_name != pam_username)
   {
-    struct passwd *pwd;
-    string log;
-    uid_t uid;
-    gid_t gid;
+      logging->log_this(4, LOG_INFO, "PAM changed username of " +
+          user->user_name + " to " + pam_username);
+      user->user_name = pam_username;
+    }
+
     Commands::ftp_send(user, "230 Password accepted, proceeding.");
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->logged_in = LOGGED_IN;
-    pthread_mutex_unlock(&user->lock);
-    setpwent();
-    pwd = getpwnam(user->user_name.c_str());
-    uid = pwd->pw_uid;
-    gid = pwd->pw_gid;
-    pthread_mutex_lock(&user->lock);
+    sem_post(&user->user_lock);
+    getpwnam_r(user->user_name.c_str(), &pwd, pwdata, sizeof(pwdata), &pwd_ptr);
+    uid_t uid = pwd.pw_uid;
+    gid_t gid = pwd.pw_gid;
+    sem_wait(&user->user_lock);
     if(config->get_user(user->user_name).only_home)
-      user->root_dir = pwd->pw_dir;
-    user->current_dir = pwd->pw_dir;
-    pthread_mutex_unlock(&user->lock);
-    log = "User " + user->user_name + " logged in.";
-    endpwent();
-    pthread_mutex_lock(&sys_log_lock);
-    syslog(LOG_INFO, log.c_str());
-    pthread_mutex_unlock(&sys_log_lock);
+      user->root_dir = pwd.pw_dir;
+    user->current_dir = pwd.pw_dir;
+    sem_post(&user->user_lock);
     setgid(gid);
-    setuid(uid); // dropping permissions...
+    seteuid(uid); // dropping permissions...
     return(true);
   }
+  sem_post(&user->user_lock);
+  ftp_send(user, "530 Login denied.");
+  return(false);
 }
 
-bool Commands::help(User *user, string argument)
+bool Commands::help(User *user, string argument, unsigned int flag)
 {
   string message;
-  if(argument == "")
+  if(!argument.size())
   {
     int cmd = 0;
     message = "214-The following commands are understood:\r\n ";
@@ -186,7 +173,7 @@ bool Commands::help(User *user, string a
     {
       if(cmd != 0 && cmd % 8 == 0)
         message += "\r\n ";
-      if(handler.cmd_info[cmd].hlp_info != NULL)
+      if(handler.cmd_info[cmd].hlp_info.size() != 0)
         message += handler.cmd_info[cmd].command + "\t";
       cmd++;
     }
@@ -195,11 +182,11 @@ bool Commands::help(User *user, string a
   else
   {
     // other help stuff here...
-    int cmd;
     message  = "214 Syntax: ";
-    util.upper(argument);
-    for(cmd = 0; handler.cmd_info[cmd].command != "\n"; cmd++)
-      if(handler.cmd_info[cmd].command == argument && handler.cmd_info[cmd].hlp_info != NULL)
+    transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
+    int cmd = 0;
+    for(; handler.cmd_info[cmd].command != "\n"; cmd++)
+      if(handler.cmd_info[cmd].command == argument && handler.cmd_info[cmd].hlp_info.size() != 0)
       {
         message += handler.cmd_info[cmd].command + handler.cmd_info[cmd].hlp_info;
         break;
@@ -212,26 +199,35 @@ bool Commands::help(User *user, string a
   return(true);
 }
 
-bool Commands::cwd(User *user, string dir)
+bool Commands::cwd(User *user, string dir, unsigned int flag)
 { 
   struct stat stt;
-  string message, new_dir = Commands::parsedir(user, dir);
+  string message, new_dir;
+  DIR *tmp_dir;
+
+  if(util.is_set(flag, COM_CDUP))
+    dir = "..";
+
+  if((user->root_dir.size() > 1 && (user->current_dir.size() == user->root_dir.size())) && (dir == ".." || dir == "."))
+    new_dir = user->root_dir;
+  else
+    new_dir = Commands::parsedir(user, dir);
+
   
   lstat(new_dir.c_str(), &stt);
 
   if(S_ISLNK(stt.st_mode))
   {
-    char *real_name = new char[65];
+    char real_name[65] = { 0 };
     int len;
 
     len = readlink(new_dir.c_str(), real_name, 60);
     real_name[len] = '\0';
     
     new_dir = Commands::parsedir(user, real_name);
-    delete[] real_name;
   }
   
-  if(!opendir(new_dir.c_str()))
+  if(!(tmp_dir = opendir(new_dir.c_str())))
   {
     if(errno == EACCES)
       message = "550 '" + new_dir + "' permission denied.";
@@ -240,23 +236,25 @@ bool Commands::cwd(User *user, string di
   }
   else
   {
+    if(util.is_set(flag, COM_CDUP))
+      message = "200 'CDUP' command successful.";
+    else // COM_CWD
     message = "250 'CWD' command successful.";
-    pthread_mutex_lock(&user->lock);
+
+    sem_wait(&user->user_lock);
     user->current_dir = new_dir;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
   }
+  closedir(tmp_dir);
   ftp_send(user, message);
   return(true);
 }
 
-bool Commands::retr(User *user, string file)
+bool Commands::retr(User *user, string file, unsigned int flag)
 {
-  string file_name;
-  int file_id;
   struct stat stt;
-  class Data *data;
   
-  file_name = parsedir(user, file);
+  string file_name = parsedir(user, file);
   stat(file_name.c_str(), &stt);
   if(!S_ISREG(stt.st_mode))
   {
@@ -264,59 +262,48 @@ bool Commands::retr(User *user, string f
     return(false);
   }
   
-  file_id = open(file_name.c_str(), O_RDONLY);
+  int file_id = open(file_name.c_str(), O_RDONLY);
   if(user->rest_pos > 0)
   {
     lseek(file_id, user->rest_pos, SEEK_SET);
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->rest_pos = 0;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
   }
   
-  ftp_send(user, "150 Opening " + (string)(is_set(user->settings, BINARY)?"BINARY":"ASCII") + " mode data connection for \"" + file + "\" (" + util.itos(stt.st_size) + " bytes).");
+  ftp_send(user, "150 Opening " + static_cast<string>(user->settings.test(BINARY)?"BINARY":"ASCII") + " mode data connection for \"" + file + "\" (" + util.itos(stt.st_size) + " bytes).");
   
-  data = new Data(user, file_id, file_name, 1);
-  if(!data->isOpen())
-  {
-    ftp_send(user, "425 Can't open data connection.");
-    delete data;
-    return(false);
-  }
-  else if(user->data_vec_full())
+  class Data *data = new Data(user, file_id, file_name, 1);
+  if(!data->isOpen() || user->data_vec_full())
   {
     ftp_send(user, "425 Can't open data connection.");
     delete data;
     return(false);
   }
   
-  pthread_mutex_lock(&user->lock);
+  sem_wait(&user->user_lock);
   if(user->rest_pos > 0)
   {
-    pthread_mutex_lock(&data->data_lock);
+    sem_wait(&data->data_lock);
     data->rest_pos = user->rest_pos;
-    pthread_mutex_unlock(&data->data_lock);
+    sem_post(&data->data_lock);
     user->rest_pos = 0;
   }
 
   user->data_vec.push_back(data);
-  pthread_mutex_unlock(&user->lock);
-  pthread_create(&data->thread_id, NULL, data_wrapper, (void*)data);
+  sem_post(&user->user_lock);
+  pthread_create(&data->thread_id, NULL, data_wrapper, static_cast<void*>(data));
   pthread_detach(data->thread_id);
   return(true);
 }
 
-bool Commands::stor(User *user, string file)
+bool Commands::stor(User *user, string file, unsigned int flag)
 {
-  string file_name;
-  class Data *data;
-  int file_id, com_type;
-
-  com_type = file[0];
-  file.erase(0, 1);
+  int file_id;
 
-  file_name = parsedir(user, file);
+  string file_name = parsedir(user, file);
   
-  if(com_type == COM_STOR)
+  if(util.is_set(flag, COM_STOR))
     file_id = open(file_name.c_str(), O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
   else // com_type == COM_APPE
     file_id = open(file_name.c_str(), O_WRONLY|O_APPEND|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
@@ -336,59 +323,52 @@ bool Commands::stor(User *user, string f
     return false;
   }
   
-  if(user->rest_pos > 0 && com_type == COM_STOR) // shouldn't try to restart an appending :p
+  if(user->rest_pos > 0 && util.is_set(flag, COM_STOR)) // shouldn't try to restart an appending :p
   {
     lseek(file_id, user->rest_pos, SEEK_SET);
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->rest_pos = 0;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
   }
   
-  ftp_send(user, "150 Opening " + (string)(is_set(user->settings, BINARY)?"BINARY":"ASCII") + " mode data connection for \"" + file + "\".");
+  ftp_send(user, "150 Opening " + static_cast<string>(user->settings.test(BINARY)?"BINARY":"ASCII") + " mode data connection for \"" + file + "\".");
 
-  data = new Data(user, file_id, file_name, 0);
-  if(!data->isOpen())
-  {
-    ftp_send(user, "425 Can't open data connection.");
-    delete data;
-    return(false);
-  }
-  else if(user->data_vec_full())
+  class Data *data = new Data(user, file_id, file_name, 0);
+  if(!data->isOpen() || user->data_vec_full())
   {
     ftp_send(user, "425 Can't open data connection.");
     delete data;
     return(false);
   }
 
-  pthread_mutex_lock(&user->lock);
-  if(user->rest_pos > 0 && com_type == COM_STOR) // shouldn't try to restart an appending :p
+  sem_wait(&user->user_lock);
+  if(user->rest_pos > 0 && util.is_set(flag, COM_STOR)) // shouldn't try to restart an appending :p
   {
     lseek(file_id, user->rest_pos, SEEK_SET);
-    pthread_mutex_lock(&data->data_lock);
+    sem_wait(&data->data_lock);
     data->rest_pos = user->rest_pos;
-    pthread_mutex_unlock(&data->data_lock);
+    sem_post(&data->data_lock);
     user->rest_pos = 0;
   }
   
   user->data_vec.push_back(data);
-  pthread_mutex_unlock(&user->lock);
-  pthread_create(&data->thread_id, NULL, data_wrapper, (void*)data);
+  sem_post(&user->user_lock);
+  pthread_create(&data->thread_id, NULL, data_wrapper, static_cast<void*>(data));
   pthread_detach(data->thread_id);
   return(true);
 }
 
-bool Commands::rest(User *user, string argument)
+bool Commands::rest(User *user, string argument, unsigned int flag)
 {
   char *endptr;
-  long int fpos;
   string message;
   
-  fpos = strtoull(argument.c_str(), &endptr, 0);
+  unsigned long fpos = strtoul(argument.c_str(), &endptr, 0);
   if(!*endptr)
   {
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->rest_pos = fpos;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
     message = "350 Restarting at " + argument + ". Send STOR or RETR.";
   }
   else
@@ -398,183 +378,209 @@ bool Commands::rest(User *user, string a
   return(true);
 }
 
-bool Commands::list(User *user, string argument)
+bool Commands::list(User *user, string argument, unsigned int flag)
 {
   struct stat stt;
-  string file, message;
-  int type;
-  class Data *data;
-  bool ret;
+  string failure;
+
+  if(argument.size() == 0)
+    argument = user->current_dir;
   
-  type = argument[0];
-  argument.erase(0, 1);
+  string file = parsedir(user, argument);
+  int stat_err = lstat(file.c_str(), &stt);
 
-  if(type == COM_LONG && argument[0] == '-')
+  if(stat_err == -1 && ((util.is_set(flag, COM_LONG) || util.is_set(flag, COM_MLSD)) && argument[0] == '-'))
   {
     class StringTokenizer *token = new StringTokenizer(argument, " ", false);
     token->nextToken();
     argument = token->restTokens();
     delete token;
-  }
-  if(argument == "")
-    argument = user->current_dir;
-
   file = parsedir(user, argument);
-  lstat(file.c_str(), &stt);
+    stat_err = lstat(file.c_str(), &stt);
+  }
 
-  if(!S_ISDIR(stt.st_mode) && type == COM_MLSD)
+  if(!S_ISDIR(stt.st_mode) && util.is_set(flag, COM_MLSD))
   {  
     ftp_send(user, "501 Argument to MLSD has to be a directory.");
     return false;
   }
 
-  data = new Data(user);
+  class Data *data = new Data(user);
 
   if(!data->isOpen())
-  {
-    ftp_send(user, "425 Can't open data connection.");
-    ret = false;
-  }
+    failure = "425 Can't open data connection.";
   else
   {
+    string message;
+    size_t write_size = READ_SIZE;
     if(S_ISDIR(stt.st_mode))
     {
-      struct dirent **dirstr;
-      int num_files, files_past;
+      struct dirent dirstr, *dirptr;
+      vector<string> dirlist;
+
+      DIR *dirp = opendir(file.c_str());
+      while((readdir_r(dirp, &dirstr, &dirptr) == 0) && dirptr != NULL)
+      {
+#ifdef _DIRENT_HAVE_D_TYPE
+        if((dirstr.d_type == DT_DIR) && util.is_set(flag, COM_SHORT))
+          continue;
+#endif // _DIRENT_HAVE_D_TYPE
+        dirlist.push_back(dirstr.d_name);
+      }
+
+      closedir(dirp);
       
-      files_past = 0;
-      num_files = scandir(file.c_str(), &dirstr, 0, alphasort);
-      while(files_past < num_files)
+      sort(dirlist.begin(), dirlist.end()); // sorting the directory so we output first things first
+      for(vector<string>::iterator dir_it = dirlist.begin(); dir_it != dirlist.end(); dir_it++)
       {
-        if(type == COM_LONG)
-          message.append(list_file(user, dirstr[files_past]->d_name));
-        else if(type == COM_MLSD)
-          message.append(mlsx(user, parsedir(user, dirstr[files_past]->d_name)));
+        if(util.is_set(flag, COM_LONG))
+          message += list_file(file + "/" + *dir_it);
+        else if(util.is_set(flag, COM_MLSD))
+          message += mlsx(user, file + "/" + *dir_it);
         else
-          message.append(dirstr[files_past]->d_name); // short list.
-        message.append("\r\n"); // and newline.
-        free(dirstr[files_past++]); // free the memory allocated by scandir()
+          message += *dir_it; // short list.
+
+        message += "\r\n"; // and newline.
       }
-      free(dirstr); // and the last memory from scandir()
     }
     else
     {
-      if(type == COM_LONG)
-        message.append(list_file(user, argument)); 
+      if(util.is_set(flag, COM_LONG))
+        message += list_file(file);
       else
-        message.append(argument);
-      message.append("\r\n");
+        message += argument;
+      message += "\r\n";
     }   
-    pthread_mutex_lock(&data->data_lock);
+    sem_wait(&data->data_lock);
 #ifdef USE_TLS
-    if(is_set(user->settings, TLS_PROT_D))
+    if(user->settings.test(TLS_PROT_D))
     {
       ftp_send(user, "150 Opening PROTECTED ASCII mode data connection for file list.");
       if(gnutls_handshake(data->data_session) < 0) // handshake failed
-        ftp_send(user, "451 Failed to negotiate TLS as was asked. Closing data connection.");
+        failure =  "451 Failed to negotiate TLS as was asked. Closing data connection.";
       else
-        gnutls_record_send(data->data_session, (void*)message.c_str(), message.size());
+        write_size = gnutls_record_get_max_size(data->data_session);
     }
     else
-    {
-#endif // USE_TLS
+#endif
     ftp_send(user, "150 Opening ASCII mode data connection for file list.");
-    write(data->data_id, (void*)message.c_str(), message.size());
+
+
+    size_t written = 0;
+    struct timeval tv = { 1,0 };
+    fd_set wfds;
+    FD_ZERO(&wfds);
+    FD_SET(data->data_id, &wfds);
+
+    if(!select(data->data_id + 1, NULL, &wfds, NULL, &tv))
+      failure = "425 Data connection lost.";
+
+    while(written < message.size() && !failure.size())
+    {
+      string writing;
+
+      writing.assign(message, written, write_size);
 #ifdef USE_TLS
-    } // else to using TLS for data at all..
+      if(user->settings.test(TLS_PROT_D))
+      {
+        if(failure.size() == 0)
+          written += gnutls_record_send(data->data_session, static_cast<const void*>(writing.c_str()), writing.size());
+      } else
 #endif // USE_TLS
+        written += write(data->data_id, static_cast<const void*>(writing.c_str()), writing.size());
+    }
     close(data->data_id);
-    pthread_mutex_unlock(&data->data_lock);
-    ftp_send(user, "226 Transfer complete.");
-    ret = true;
+    sem_post(&data->data_lock);
+    sem_wait(&user->user_lock);
+    user->total_transfered += written;
+    sem_post(&user->user_lock);
   }
+  if(failure.size() > 0)
+    ftp_send(user, failure);
+  else
+    ftp_send(user, "226 Transfer complete.");
   delete data;
-  return(ret);
+  return(true);
 }
 
-string Commands::list_file(User *user, string file)
+string Commands::list_file(string file_name)
 {
-  char *time_string, *size, *nlink;
-  string user_name, group_name, message, file_name;
+  char size[20], nlink[6], time_string[25], pwdbuf[PWBUF_SIZE], grpbuf[PWBUF_SIZE];
+  string user_name, group_name;
   struct stat file_stat;
-  struct passwd *pwd;
-  struct group *grp;
-  setpwent();
-  setgrent();
-                                        
-  file_name = parsedir(user, file);
-
-  size = new char[20];
-  nlink = new char[20];
-  time_string = new char[25];
-  memset(size, '\0', 20);
-  memset(nlink, '\0', 20);
-  memset(time_string, '\0', 25);
+  struct passwd pwd, *pwd_ptr;
+  struct group grp, *grp_ptr;
+  struct tm file_time;
+
   lstat(file_name.c_str(), &file_stat);
 
-  sprintf(nlink, "%3d ", file_stat.st_nlink); // number of hard links
+  snprintf(nlink, 5, "%3d ", static_cast<int>(file_stat.st_nlink)); // number of hard links
 
-  if((pwd = getpwuid(file_stat.st_uid))) // username
-    user_name = pwd->pw_name;
+  if((getpwuid_r(file_stat.st_uid, &pwd, pwdbuf, sizeof(pwdbuf), &pwd_ptr)) == 0)
+    user_name = pwd.pw_name;
   else
     user_name = util.itos(file_stat.st_uid);
   
-  if((grp = getgrgid(file_stat.st_gid))) // groupname
-    group_name = grp->gr_name;
+  if((getgrgid_r(file_stat.st_gid, &grp, grpbuf, sizeof(grpbuf), &grp_ptr)) == 0)
+    group_name = grp.gr_name;
   else
     group_name = util.itos(file_stat.st_gid);
 
-  sprintf(size, "%9d ", (int)file_stat.st_size); // filesize
+  snprintf(size, 19, "%9d ", static_cast<int>(file_stat.st_size)); // filesize
 
-  strftime(time_string, 24, "%b %e %R ", localtime(&file_stat.st_mtime)); // modification time
-
-  message += (util.parse_perms_ls(file_stat.st_mode) + ' ') + nlink + user_name + '\t' + group_name + '\t' + size + time_string + file; // parsing everything on one line is neater.
+  gmtime_r(&file_stat.st_mtime, &file_time);
+  // modification time, either in new ls format, or old..
+#ifdef USE_NEWLS
+  strftime(time_string, 24, "%Y-%m-%d %H:%M ", &file_time);
+#else
+  if((time(NULL) - file_stat.st_mtime) > (60 * 60 * 24 * 365)) // is the file over a year old?
+    strftime(time_string, 24, "%b %e  %Y ", &file_time);
+  else // if it's not, we display the time it was created as well.
+    strftime(time_string, 24, "%b %e %H:%M ", &file_time);
+#endif // USE_NEWLS
+
+  string message = (util.parse_perms_ls(file_stat.st_mode) + ' ')
+    + nlink + user_name + '\t' + group_name + '\t' + size + time_string
+    + basename(file_name.c_str()); // parsing everything on one line is neater.
  
   // if it's a link...
   if(S_ISLNK(file_stat.st_mode))
   {
-    char *real_name = new char[55];
-    int len;
-    len = readlink(file_name.c_str(), real_name, 50);  
+    char real_name[55];
+    int len = readlink(file_name.c_str(), real_name, 50);
     real_name[len] = '\0';
     message += " -> ";
     message += real_name;
-    delete[] real_name;
   }
-  
-  endpwent();
-  endgrent();
-  delete[] time_string;
-  delete[] nlink;
-  delete[] size;
   return(message);
 }
 
 string Commands::mlsx(User *user, string file_name)
 {
+  char pwdbuf[PWBUF_SIZE], grpbuf[PWBUF_SIZE];
+  struct passwd pwd, *pwd_ptr;
+  struct group grp, *grp_ptr;
+
   struct stat stt;
-  string message, type, user_name, group_name, file;
+  string message;
 
-  file = parsedir(user, file_name);
-  lstat(file.c_str(), &stt);
+  lstat(file_name.c_str(), &stt);
 
   // type.
-  if(is_set(user->mlst_facts, FACT_TYPE))
+  if(user->settings.test(FACT_TYPE))
   {
+    string type;
     if(S_ISREG(stt.st_mode))
       type = "file";
     else if(S_ISDIR(stt.st_mode))
     {
-      if(file == user->current_dir)
+      if(file_name == user->current_dir)
       {
         type = "cdir";
-        file += "/.";
+        file_name += "/.";
       }
-      else if(file == parsedir(user, user->current_dir + "/.."))
-      {
+      else if(file_name == parsedir(user, user->current_dir + "/.."))
         type = "pdir";
-        //file += "/.."; // this messes the string up as it is already parsed once...
-      }
       else
         type = "dir";
     }
@@ -592,37 +598,30 @@ string Commands::mlsx(User *user, string
     message =  "Type=" + type + ";";
   }
 
-  if(is_set(user->mlst_facts, FACT_SIZE))
+  if(user->settings.test(FACT_SIZE))
     message += "Size=" + util.itos(stt.st_size) + ";";
-  if(is_set(user->mlst_facts, FACT_MODIFY))
-    message += "Modify=" + mod_time(file_name, stt) + ";"; // mod time...
-  if(is_set(user->mlst_facts, FACT_UNIQUE))
+  if(user->settings.test(FACT_MODIFY))
+    message += "Modify=" + mod_time(stt) + ";"; // mod time...
+  if(user->settings.test(FACT_UNIQUE))
     message += "Unique=" + util.itos(stt.st_dev) + "g" + util.itos(stt.st_ino) + ";";
-  if(is_set(user->mlst_facts, FACT_PERM))
+  if(user->settings.test(FACT_PERM))
     {
       bool owner = false, group = false;
-      struct passwd *pwd;
-      struct group *grp;
       
-      setpwent();
-      if((pwd = getpwnam(user->user_name.c_str())))
+    if(getpwnam_r(user->user_name.c_str(), &pwd, pwdbuf, sizeof(pwdbuf), &pwd_ptr))
       {
-        if(pwd->pw_uid == stt.st_uid)
+      if(pwd.pw_uid == stt.st_uid)
           owner = true;
-        else if(pwd->pw_gid == stt.st_gid)
+      else if(pwd.pw_gid == stt.st_gid)
           group = true;
       }
-      endpwent();
 
       if(!group && !owner)
       {
-        setgrent();
-        if((grp = getgrgid(stt.st_gid)))
-          for(int i = 0; grp->gr_mem[i] != NULL; i++)
-            if(user->user_name == grp->gr_mem[i])
+      if(getgrgid_r(stt.st_gid, &grp, grpbuf, sizeof(grpbuf), &grp_ptr))
+        for(int i = 0; grp.gr_mem[i] != NULL; i++)
+          if(user->user_name == grp.gr_mem[i])
               group = true;
-        
-        endgrent();
       }
       
       message += "Perm=";
@@ -630,54 +629,54 @@ string Commands::mlsx(User *user, string
       {
         if(S_ISDIR(stt.st_mode))
         {
-          if(test(stt.st_mode, S_IRUSR)) message += "l";
-          if(test(stt.st_mode, S_IWUSR)) message += "cmp";
-          if(test(stt.st_mode, S_IXUSR)) message += "e";
+        if(util.test(stt.st_mode, S_IRUSR)) message += "l";
+        if(util.test(stt.st_mode, S_IWUSR)) message += "cmp";
+        if(util.test(stt.st_mode, S_IXUSR)) message += "e";
         }
-        if(test(stt.st_mode, S_IRUSR)) message += "r";
-        if(test(stt.st_mode, S_IWUSR)) message += "adfw";
+      if(util.test(stt.st_mode, S_IRUSR)) message += "r";
+      if(util.test(stt.st_mode, S_IWUSR)) message += "adfw";
       }
       else if(group)
       {
         if(S_ISDIR(stt.st_mode))
         {
-          if(test(stt.st_mode, S_IRGRP)) message += "l";
-          if(test(stt.st_mode, S_IWGRP)) message += "cmp";
-          if(test(stt.st_mode, S_IXGRP)) message += "e";
+        if(util.test(stt.st_mode, S_IRGRP)) message += "l";
+        if(util.test(stt.st_mode, S_IWGRP)) message += "cmp";
+        if(util.test(stt.st_mode, S_IXGRP)) message += "e";
         }
-        if(test(stt.st_mode, S_IRGRP)) message += "r";
-        if(test(stt.st_mode, S_IWGRP)) message += "adfw";
+      if(util.test(stt.st_mode, S_IRGRP)) message += "r";
+      if(util.test(stt.st_mode, S_IWGRP)) message += "adfw";
       }
       else
       {
         if(S_ISDIR(stt.st_mode))
         { 
-          if(test(stt.st_mode, S_IROTH)) message += "l";
-          if(test(stt.st_mode, S_IWOTH)) message += "cmp";
-          if(test(stt.st_mode, S_IXOTH)) message += "e";
+        if(util.test(stt.st_mode, S_IROTH)) message += "l";
+        if(util.test(stt.st_mode, S_IWOTH)) message += "cmp";
+        if(util.test(stt.st_mode, S_IXOTH)) message += "e";
         }
-        if(test(stt.st_mode, S_IROTH)) message += "r";
-        if(test(stt.st_mode, S_IWOTH)) message += "adfw";
+      if(util.test(stt.st_mode, S_IROTH)) message += "r";
+      if(util.test(stt.st_mode, S_IWOTH)) message += "adfw";
       }
       message += ";";
     }
-  if(is_set(user->mlst_facts, FACT_U_MODE))
+  if(user->settings.test(FACT_U_MODE))
     message += "Unix.mode=" + util.parse_perms_num(stt.st_mode) + ";";
-  if(is_set(user->mlst_facts, FACT_U_UID))
+  if(user->settings.test(FACT_U_UID))
     message += "Unix.uid=" + util.itos(stt.st_uid) + ";";
-  if(is_set(user->mlst_facts, FACT_U_GID))
+  if(user->settings.test(FACT_U_GID))
     message += "Unix.gid=" + util.itos(stt.st_gid) + ";";
-  if(is_set(user->mlst_facts, FACT_U_LINK))
+  if(user->settings.test(FACT_U_LINK))
     message += "Unix.link=" + util.itos(stt.st_nlink) + ";";
-  if(config->get_user(user->user_name).only_home)
-    file.erase(0, user->root_dir.size());
-  message += " " + file;
+  if(user->root_dir.size() > 1)
+    file_name.erase(0, user->root_dir.size());
+  message += " " + file_name;
 
   return(message);
 }
 
 
-bool Commands::mkd(User *user, string dir)
+bool Commands::mkd(User *user, string dir, unsigned int flag)
 {
   string message, new_dir = parsedir(user, dir);
 
@@ -700,7 +699,7 @@ bool Commands::mkd(User *user, string di
   return(true);
 }
 
-bool Commands::rmd(User *user, string dir)
+bool Commands::rmd(User *user, string dir, unsigned int flag)
 {
   string message, new_dir = parsedir(user, dir);
   
